#include "precompile.h"

#include "jsondatamgr.h"
#include "app.h"

#include "framework/cpp/utils.h"

void JsonDataMgr::Init()
{
    std::string gameserver_cluster_json_file;
    if (!f8::IsOnlineEnv()) {
        if (App::Instance()->flags.find(2) != App::Instance()->flags.end()) {
            gameserver_cluster_json_file = a8::Format("/root/pub/%d/%d/conf_test/game%d/gameserver/"
                                                      "game%d.gameserver.cluster.json",
                                                      {
                                                       GAME_ID,
                                                       App::Instance()->instance_id,
                                                       GAME_ID,
                                                       GAME_ID
                                                      });
        } else {
            gameserver_cluster_json_file = a8::Format("/var/data/conf_test/game%d/gameserver/"
                                                      "game%d.gameserver.cluster.json",
                                                      {GAME_ID, GAME_ID});
        }
    } else {
        gameserver_cluster_json_file = a8::Format("../config/game%d.gameserver.cluster.json", {GAME_ID});
    }
    gameserver_cluster_json_.ReadFromFile(gameserver_cluster_json_file);
}

void JsonDataMgr::UnInit()
{
}

std::shared_ptr<a8::XObject> JsonDataMgr::GetConf()
{
    if (App::Instance()->instance_id < 1 || App::Instance()->instance_id > gameserver_cluster_json_.Size()) {
        abort();
    }
    return gameserver_cluster_json_[App::Instance()->instance_id - 1];
}
