#pragma once

struct PerfMonitor
{
    int max_run_delay_time = 0;
    int max_timer_idle = 0;
    long long out_data_size = 0;
    long long in_data_size = 0;
    long long read_count = 0;
};

namespace MetaData
{
    struct SafeArea;
    struct Equip;
}

struct GasData
{
    GasMode_e gas_mode = GasInactive;
    Vector2D pos_old;
    Vector2D pos_old_bk;
    Vector2D pre_pos_old;
    Vector2D pos_new;
    float rad_old = 0.0f;
    float rad_new = 0.0f;
    float gas_progress = 0.0f;
    long long gas_start_frameno = 0;
    MetaData::SafeArea* old_area_meta = nullptr;
    MetaData::SafeArea* new_area_meta = nullptr;
    bool is_last_gas = false;
};

struct Weapon
{
    int weapon_idx = 0;
    int weapon_id = 0;
    int weapon_lv = 0;
    int ammo = 0;
    MetaData::Equip* meta = nullptr;

    void ToPB(cs::MFWeapon* pb_obj);
};

struct PlayerStats
{
    int kills = 0;
    int damage_amount_in = 0;
    int damage_amount_out = 0;
    int heal_amount = 0;
    int rescue_member = 0;

    int history_time_alive = 0;
    int history_kills = 0;
    int history_damage_amount = 0;
    int history_heal_amount = 0;

    int gold = 0;
    int score = 0;

    int killer_id = 0;
    std::string killer_name;
    int weapon_id = 0;

};

struct Plane
{
    Vector2D start_point;
    Vector2D end_point;
    Vector2D dir;
    Vector2D curr_pos;
};

struct HumanAbility
{
    float speed = 0.0f;
    float damage_add = 0.0f;
    float def_add = 0.0f;
    float reflect_damage = 0.0f;
};
