import websocket
import sys
import time

import vs_proto_pb2
import vs_msgid_pb2

try:
    import thread
except ImportError:
    import _thread as thread
import time

def on_open (ws):
    print 'on open'

class Client:

    def __init__(self, accountid, user_profile, remote_ip, remote_port):
        self._recv_buf = bytearray()
        self._accountid = accountid
        self._sessionid = ''
        self._user_profile = user_profile
        self._ws = websocket.WebSocketApp ("ws://127.0.0.1:" + sys.argv[1],
                                           on_message = self.onMessage,
                                           on_error = self.onError,
                                           on_close = self.onClose)
#        self._ws.on_open = on_open
        self._ws.on_open = self.onOpen

    def sendMsg(self, msgid, msg):
        PACK_SIGN = 0xAABBCCAA
        enmsg = bytearray(msg.SerializeToString())
        pktlen_str = chr(len(enmsg) & 0xFF) + chr(len(enmsg) >> 8 & 0xFF)
        msgid_str = chr(msgid & 0xFF) + chr(msgid >> 8 & 0xFF)
        sign_str = chr(PACK_SIGN & 0xFF) + chr(PACK_SIGN >> 8 & 0xFF) + \
                   chr(PACK_SIGN >> 16 & 0xFF) + chr(PACK_SIGN >> 24 & 0xFF)
        buff = pktlen_str + msgid_str + sign_str + enmsg
        self._ws.send (buff, 2)

    def parsePacket(self):
        while len(self._recv_buf) >= 8:
            pktlen = self._recv_buf[0] + (self._recv_buf[1] << 8)
            msgid = self._recv_buf[2] + (self._recv_buf[3] << 8)
            magiccode = self._recv_buf[4] + \
                        (self._recv_buf[5] << 8) + \
                        (self._recv_buf[6] << 16) + \
                        (self._recv_buf[7] << 24)
            print 'pkglen:', pktlen, ' msgid:', msgid, ' magiccode:', magiccode
            if len(self._recv_buf) >= 8 + pktlen:
                msgbody = self._recv_buf[8 : 8 + pktlen]
                self.onUserPacket(msgid, msgbody)
                self._recv_buf = self._recv_buf[8 + pktlen:]

    def onUserPacket(self):
        try:
            msgid_class_hash = {
                vs_msgid_pb2._SMLogin: vs_proto_pb2.SMLogin,
                vs_msgid_pb2._SMCreateRoom: vs_proto_pb2.SMCreateRoom
            }
            if not msgid_class_hash.has_key(msgid):
                print 'not found msgclass:', msgid
                return
            msg = msgid_class_hash[msgid]()
            ret = msg.ParseFromString(str(msgbody))
            print str(msg)
        except Exception, e:
            print 'on_user_packet', e

    def onMessage(self, message):
        data = bytearray(message)
        self._recv_buf +=  data
        print 'on_message ', len(recv_buf)
        self._ws.parsePacket();

    def onError(self, error):
        print error

    def onClose(self):
        print 'onclose'

    def onOpen(self):
        print 'ok'
        def run (*args):
            msg = vs_proto_pb2.CMLogin()
            msg.account_id = '1234567'
            msg.session_id = 'dsjfkasjkfljfsklfd'
            print msg
            sendmsg(ws, vs_msgid_pb2._CMLogin, msg)
            testCMCreateRoom(ws)
            while True:
                testSendRoomEvent(ws)
                time.sleep(10)

        time.sleep(500)
        ws.close ()
        print ("thread terminating...")
        thread.start_new_thread (run, ())

    def runForever(self):
        self._ws.run_forever()

if __name__ == "__main__":
    client = Client(
        '123456',
        '',
        '127.0.0.1',
        82
    )
    client.runForever()
