from optparse import OptionParser

from tornado import gen
from tornado import httpclient
from tornado import httputil
from tornado import ioloop
from tornado import websocket

import virtualclient

@gen.coroutine
def createVirtualClient(account, ws_url):
    virtualclient.VirtualClient(ws_url, account).run()

@gen.coroutine
def main():
    parser = OptionParser(usage="%prog [options]")
    parser.add_option("-a",
                      "--accounts",
                      dest = "accounts",
                      help = "account info")
    (options, args) = parser.parse_args()

    ws_url = args if args else 'ws://127.0.0.1:83/websocket'
    for account in options.accounts.split(','):
        ioloop.IOLoop.current().spawn_callback(createVirtualClient, account, ws_url)

    while True:
        yield gen.sleep(0.1)

if __name__ == '__main__':
    ioloop.IOLoop.current().run_sync(main)
