# -*- coding: utf-8 -*-
import websocket
import sys
import ssl
import datetime

import cs_proto_pb2
import cs_msgid_pb2

#from google.protobuf import json_format
import pprint

try:
    import thread
except ImportError:
    import _thread as thread
import time

def inputCommand(ws):
    cmdline= raw_input('')
    idx = cmdline.find(' ')
    if idx <= 0:
        cmdline += '()'
    else:
        cmdline = cmdline[:idx] + '(' + cmdline[idx + 1:] + ')'
    msg = eval('cs_proto_pb2.' + cmdline)
    sendMsg(ws, msg)
    inputCommand(ws)

def getSMMsgEnum(sm_msgid):
    sm_e = cs_msgid_pb2._SMMESSAGEID_E
    for e in sm_e.values:
        if e.number == sm_msgid:
            return e
    return None

def getSMMsg(sm_msgid):
    sm_e = getSMMsgEnum(sm_msgid)
    msg = eval('cs_proto_pb2.' + sm_e.name[1:] + '()')
    return msg

#g_remote_ip = "ws://127.0.0.1:" + sys.argv[1]
g_remote_ip = sys.argv[1]
g_account_id = sys.argv[2]
g_session_id = sys.argv[3]
g_seqid = 1000

recv_buf = bytearray()

def sendMsg(ws,  msg):
    print datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S.%f')
    global g_seqid
    ++g_seqid
    msgid = eval('cs_msgid_pb2._' + msg.DESCRIPTOR.name)
    PACK_SIGN = 'KS'
    enmsg = bytearray(msg.SerializeToString())
    pktlen_str = chr(len(enmsg) & 0xFF) + chr(len(enmsg) >> 8 & 0xFF)
    msgid_str = chr(msgid & 0xFF) + chr(msgid >> 8 & 0xFF)
    seqid_str = chr(g_seqid & 0xFF) + chr(g_seqid >> 8 & 0xFF) + \
                chr(g_seqid >> 16 & 0xFF) + chr(g_seqid >> 24 & 0xFF)
    sign_str = PACK_SIGN
    reserved_str = chr(0) + chr(0)
    buff = pktlen_str + msgid_str + seqid_str + sign_str + reserved_str + enmsg
    ws.send (buff, 2)
    print time.time(), time.strftime('[%H:%M:%S]'), msg.DESCRIPTOR.name + '{'
    print str(msg),
    print '}'
    print ''

def onMessage(ws, message):
    global recv_buf

    print 'onMessage', len(message)
    data = bytearray(message)
    recv_buf +=  data
    parserPacket(ws)

def parserPacket(ws):
    global recv_buf
    while len(recv_buf) >= 8:
        pktlen = recv_buf[0] + (recv_buf[1] << 8)
        msgid = recv_buf[2] + (recv_buf[3] << 8)
        seqid = recv_buf[4] + \
                (recv_buf[5] << 8) + \
                (recv_buf[6] << 16) + \
                (recv_buf[7] << 24)
        sign = recv_buf[8] + (recv_buf[9] << 8)
        resv = recv_buf[10] + (recv_buf[11] << 8)
        if len(recv_buf) >= 12 + pktlen:
            msgbody = recv_buf[12 : 12 + pktlen]
            onUserPacket(ws, msgid, msgbody)
            recv_buf = recv_buf[12 + pktlen:]

def onUserPacket(ws, msgid, msgbody):
    try:
        print datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S.%f')
        msg = getSMMsg(msgid)
        ret = msg.ParseFromString(str(msgbody))
        print len(msgbody)
        print time.time(), time.strftime('[%H:%M:%S]'), msg.DESCRIPTOR.name + '{'
        print str(msg),
        print '}'
        print ''
        if msgid == cs_msgid_pb2._SMTestAward:
            print msg.default_123456
    except Exception, e:
        print 'onUserPacket', e

def onError (ws, error):
    print (error)

def onClose (ws):
    print ("### closed ###")

def opOpen (ws):
    print 'opOpen', time.time()
    def run (*args):
        global g_remote_ip
        global g_account_id
        global g_session_id
        msg = cs_proto_pb2.CMLogin()
        msg.server_id = 1
        msg.account_id = g_account_id
        msg.session_id = g_session_id
        msg.device_id = '123456'
        print msg.DESCRIPTOR.name, 'zzzzz'
        sendMsg(ws, msg)
        while True:
            inputCommand(ws)
        time.sleep(500)
        ws.close ()
        print ("thread terminating...")
    thread.start_new_thread (run, ())

print time.time()
print g_remote_ip

if __name__ == "__main__":
    websocket.enableTrace(True)
    ws = websocket.WebSocketApp (g_remote_ip,
                                 on_message = onMessage,
                                 on_error = onError,
                                 on_close = onClose
                                 )
    ws.on_open = opOpen
    ws.run_forever ()
